%global gem_name    byebug
Name:                rubygem-%{gem_name}
Version:             11.1.1
Release:             2
Summary:             Ruby 2.0 fast debugger - base + CLI
License:             BSD-2-Clause
URL:                 http://github.com/deivid-rodriguez/byebug
Source0:             https://rubygems.org/gems/%{gem_name}-%{version}.gem
Source1:             https://github.com/deivid-rodriguez/byebug/archive/v%{version}/%{name}-%{version}.tar.gz
BuildRequires:       gcc rubygems-devel ruby-devel rubygem(minitest) >= 5 rubygem(simplecov)
BuildRequires:       rubygem(pry)
%description
Byebug is a Ruby 2 debugger. It's implemented using the
Ruby 2 TracePoint C API for execution control and the Debug Inspector C API
for call stack navigation.  The core component provides support that
front-ends can build on. It provides breakpoint handling and bindings for
stack frames among other things and it comes with an easy to use command
line interface.

%package    doc
Summary:             Documentation for %{name}
Requires:            %{name} = %{version}-%{release}
BuildArch:           noarch
%description doc
Documentation for %{name}.

%prep
%setup -q -T -n %{gem_name}-%{version} -b 1
gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec
sed -i %{gem_name}.gemspec -e '\@columnize@s|= [0-9\.][0-9\.]*|>= 0.8.9|'

%build
gem build %{gem_name}.gemspec
%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
    %{buildroot}%{gem_dir}/
mkdir -p %{buildroot}%{gem_extdir_mri}
cp -a .%{gem_extdir_mri}/{gem.build_complete,%{gem_name}/} %{buildroot}%{gem_extdir_mri}/
rm -rf %{buildroot}%{gem_instdir}/ext/
mkdir -p %{buildroot}%{_bindir}
cp -pa .%{_bindir}/* \
    %{buildroot}%{_bindir}/
find %{buildroot}%{gem_instdir}/exe -type f | xargs chmod a+x

%check
export GEM_PATH=%{buildroot}/%{gem_dir}:%{gem_dir}
export PATH=%{buildroot}%{_bindir}:$PATH
remove_fail_test() {
    filename=$1
    shift
    num=$#
    while [ $num -gt 0 ]
    do
        if [ ! -f ${filename}.orig ] ; then
            cp -p $filename ${filename}.orig
        fi
        sed -i $filename -e "\@def.*$1@s|^\(.*\)$|\1; skip \"Skip this\"|"
        shift
        num=$((num - 1))
    done
}
sed -i bin/minitest -e '$s|^Byebug|exit 1 unless Byebug|'
mv {,.}Gemfile.lock
sed -i bin/minitest \
    -e '\@bundler/setup@d' \
    -e '\@load.*expand_path.*bundle@d' \
    %{nil}
remove_fail_test test/minitest_runner_test.rb run_minitest_runner
export RUBYLIB=$(pwd):$(pwd)/lib:%{buildroot}%{gem_extdir_mri}
ruby bin/minitest || true
remove_fail_test test/commands/finish_test.rb test_finish_inside_autoloaded_files
ruby bin/minitest
mv {.,}Gemfile.lock

%files
%dir    %{gem_instdir}
%license    %{gem_instdir}/LICENSE
%doc    %{gem_instdir}/CHANGELOG.md
%doc    %{gem_instdir}/CONTRIBUTING.md
%doc    %{gem_instdir}/GUIDE.md
%doc    %{gem_instdir}/README.md
%{_bindir}/byebug
%{gem_instdir}/exe
%{gem_libdir}/
%{gem_extdir_mri}/
%exclude    %{gem_cache}
%{gem_spec}

%files doc
%doc    %{gem_instdir}/CONTRIBUTING.md
%doc    %{gem_docdir}

%changelog
* Tue May 10 2022 yaoxin <yaoxin30@h-partners.com> - 11.1.1-2
- License compliance rectification

* Wed Aug 19 2020 maminjie <maminjie1@huawei.com> - 11.1.1-1
- package init
